'use strict';

System.register([], function (_export, _context) {
  "use strict";

  var _slicedToArray, _createClass, pluck, getRangeFrom, getRangeTo, DataSource, serieObjectConstructor, tableObjectConstructor;

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  return {
    setters: [],
    execute: function () {
      _slicedToArray = function () {
        function sliceIterator(arr, i) {
          var _arr = [];
          var _n = true;
          var _d = false;
          var _e = undefined;

          try {
            for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
              _arr.push(_s.value);

              if (i && _arr.length === i) break;
            }
          } catch (err) {
            _d = true;
            _e = err;
          } finally {
            try {
              if (!_n && _i["return"]) _i["return"]();
            } finally {
              if (_d) throw _e;
            }
          }

          return _arr;
        }

        return function (arr, i) {
          if (Array.isArray(arr)) {
            return arr;
          } else if (Symbol.iterator in Object(arr)) {
            return sliceIterator(arr, i);
          } else {
            throw new TypeError("Invalid attempt to destructure non-iterable instance");
          }
        };
      }();

      _createClass = function () {
        function defineProperties(target, props) {
          for (var i = 0; i < props.length; i++) {
            var descriptor = props[i];
            descriptor.enumerable = descriptor.enumerable || false;
            descriptor.configurable = true;
            if ("value" in descriptor) descriptor.writable = true;
            Object.defineProperty(target, descriptor.key, descriptor);
          }
        }

        return function (Constructor, protoProps, staticProps) {
          if (protoProps) defineProperties(Constructor.prototype, protoProps);
          if (staticProps) defineProperties(Constructor, staticProps);
          return Constructor;
        };
      }();

      pluck = function pluck() {
        for (var _len = arguments.length, ks = Array(_len), _key = 0; _key < _len; _key++) {
          ks[_key] = arguments[_key];
        }

        return function (x) {
          return ks.reduce(function (y, k) {
            return y && y[k];
          }, x);
        };
      };

      getRangeFrom = pluck('range', 'from');
      getRangeTo = pluck('range', 'to');

      DataSource = function () {
        function DataSource(instanceSettings, backendSrv) {
          _classCallCheck(this, DataSource);

          this.id = instanceSettings.id;
          this.backendSrv = backendSrv;
          this.url = '/api/datasources/proxy/1/opmon/ws/oracle.php?endpoint=';
        }

        _createClass(DataSource, [{
          key: 'query',
          value: function query(options) {
            var _this = this;

            var queries = options.targets.filter(function (t) {
              return !t.hide;
            }).map(function (t) {
              return {
                intervalMs: options.intervalMs,
                maxDataPoints: options.maxDataPoints,
                datasourceId: _this.id,
                refId: t.refId,
                rawSql: t.rawSql,
                format: t.format
              };
            });

            return this.backendSrv.datasourceRequest({
              url: this.url + '/query',
              data: {
                from: (getRangeFrom(options) || '').valueOf().toString(),
                to: (getRangeTo(options) || '').valueOf().toString(),
                queries: queries
              },
              method: 'POST'
            }).then(function (_ref) {
              var data = _ref.data;
              return Object.values(data.results).reduce(function (acc, result) {
                return {
                  data: result.series ? acc.data.concat(result.series.map(serieObjectConstructor(result))) : acc.data.concat(tableObjectConstructor(result))
                };
              }, { data: [] });
            });
          }
        }, {
          key: 'testDatasource',
          value: function testDatasource() {
            return this.query({
              targets: [{
                rawSql: 'SELECT 1 FROM DUAL',
                format: 'time_series',
                refId: 'A'
              }],
              range: {
                from: Date.now() - 1000 * 60 * 60,
                to: Date.now()
              }
            }).then(function () {
              return { status: 'success', message: 'Database Connection OK' };
            });
          }
        }]);

        return DataSource;
      }();

      _export('default', DataSource);

      serieObjectConstructor = function serieObjectConstructor(options) {
        return function (serie) {
          return {
            target: serie.name,
            datapoints: serie.points.map(function (_ref2) {
              var _ref3 = _slicedToArray(_ref2, 2),
                  value = _ref3[0],
                  time = _ref3[1];

              return [Number(value), Number(time)];
            }),
            refId: options.refId,
            meta: options.meta
          };
        };
      };

      tableObjectConstructor = function tableObjectConstructor(query) {
        return query.tables.map(function (t) {
          return {
            type: 'table',
            refId: query.refId,
            meta: query.meta,
            columns: t.columns,
            rows: t.rows
          };
        });
      };
    }
  };
});
//# sourceMappingURL=datasource.js.map
