'use strict';

System.register(['app/plugins/sdk'], function (_export, _context) {
  "use strict";

  var QueryCtrl, _createClass, OracleDbQueryCtrl;

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  function _possibleConstructorReturn(self, call) {
    if (!self) {
      throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }

    return call && (typeof call === "object" || typeof call === "function") ? call : self;
  }

  function _inherits(subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
      throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
    }

    subClass.prototype = Object.create(superClass && superClass.prototype, {
      constructor: {
        value: subClass,
        enumerable: false,
        writable: true,
        configurable: true
      }
    });
    if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
  }

  return {
    setters: [function (_appPluginsSdk) {
      QueryCtrl = _appPluginsSdk.QueryCtrl;
    }],
    execute: function () {
      _createClass = function () {
        function defineProperties(target, props) {
          for (var i = 0; i < props.length; i++) {
            var descriptor = props[i];
            descriptor.enumerable = descriptor.enumerable || false;
            descriptor.configurable = true;
            if ("value" in descriptor) descriptor.writable = true;
            Object.defineProperty(target, descriptor.key, descriptor);
          }
        }

        return function (Constructor, protoProps, staticProps) {
          if (protoProps) defineProperties(Constructor.prototype, protoProps);
          if (staticProps) defineProperties(Constructor, staticProps);
          return Constructor;
        };
      }();

      OracleDbQueryCtrl = function (_QueryCtrl) {
        _inherits(OracleDbQueryCtrl, _QueryCtrl);

        function OracleDbQueryCtrl($scope, $injector) {
          _classCallCheck(this, OracleDbQueryCtrl);

          var _this = _possibleConstructorReturn(this, (OracleDbQueryCtrl.__proto__ || Object.getPrototypeOf(OracleDbQueryCtrl)).call(this, $scope, $injector));

          _this.target = _this.target;
          _this.showHelp = false;
          _this.formats = [{ text: 'Time series', value: 'time_series' }, { text: 'Table', value: 'table' }];

          if (!_this.target.rawSql) {
            _this.target.format = 'time_series';
            _this.target.rawSql = 'SELECT 1 FROM dual';
            _this.target.rawQuery = true;
          }

          _this.panelCtrl.events.on('data-received', _this.onDataReceived.bind(_this), $scope);
          _this.panelCtrl.events.on('data-error', _this.onDataErrorReceived.bind(_this), $scope);
          return _this;
        }

        _createClass(OracleDbQueryCtrl, [{
          key: 'onDataReceived',
          value: function onDataReceived(dataList) {
            console.log("DATA LIST", dataList);
            return dataList;
          }
        }, {
          key: 'onDataErrorReceived',
          value: function onDataErrorReceived(error) {
            console.log("ERROR", error);
          }
        }]);

        return OracleDbQueryCtrl;
      }(QueryCtrl);

      _export('default', OracleDbQueryCtrl);

      OracleDbQueryCtrl.templateUrl = 'partials/query.editor.html';
    }
  };
});
//# sourceMappingURL=query_ctrl.js.map
