import { QueryCtrl } from 'app/plugins/sdk'

export default class OracleDbQueryCtrl extends QueryCtrl {
  constructor($scope, $injector) {
    super($scope, $injector);

    this.target = this.target;
    this.showHelp = false;
    this.formats = [{ text: 'Time series', value: 'time_series' }, { text: 'Table', value: 'table' }];

    if (!this.target.rawSql) {
      this.target.format = 'time_series';
      this.target.rawSql = 'SELECT 1 FROM dual';
      this.target.rawQuery = true;
    }

    this.panelCtrl.events.on('data-received', this.onDataReceived.bind(this), $scope);
    this.panelCtrl.events.on('data-error', this.onDataErrorReceived.bind(this), $scope);
  }

  onDataReceived(dataList) {
    console.log("DATA LIST", dataList);
    return dataList;
  }

  onDataErrorReceived(error) {
    console.log("ERROR", error);
  }
}

OracleDbQueryCtrl.templateUrl = 'partials/query.editor.html'
